﻿namespace SaxonSample
{
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text;
    using System.Xml;
    
    using global::Saxon.Api;    

    public class SaxonXslTransformer
    {
        public Stream Transform(XmlDocument xmlDocument, XmlDocument xsltDocument)
        {
            var result = new MemoryStream();

            var serializer = new Serializer();
            var processor = new Processor();
            var input = processor.NewDocumentBuilder().Wrap(xmlDocument);
            var reader = new StringReader(xsltDocument.OuterXml);

            var transformer = processor.NewXsltCompiler().Compile(reader).Load();
            transformer.InitialContextNode = input;

            serializer.SetOutputStream(result);
            transformer.Run(serializer);

            result.Position = 0;
            return result;
        }
    }
}